com.ihr.xbrl.om.instance

## Interface XBRLFactsList

- All Superinterfaces:
    XMLHasParent
  All Known Implementing Classes:
    XBRLFactsListImpl, XBRLFactTuple, XBRLInstance

      public interface XBRLFactsList
      extends XMLHasParent

  This interface provides methods for objects that contains a list of facts in document order and also possible accelerator functions to facts indexed by fact name
  Author:
    Ignacio

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `add(int index, XBRLFact fact)` Adds the.
    `boolean` | `add(XBRLFact fact)` Adds a new fact to the end of this list of facts.
    `void` | `addOrForwardItem(XBRLFactItem item)` Called internally to register new facts in the instance document.
    `void` | `clear()` Removes all children elements in this XBRLFactList.
    `boolean` | `equals(java.lang.Object obj)` This function should be implemented by sub classes in order to properly implement.
    `net.sf.saxon.s9api.XdmValue` | `evaluateList(java.lang.String string)` Access to the surrounding method in the XMLFragment.
    `XBRLFact` | `get(int index)` Returns the element at the selected index position.
    `DTSContainer` | `getContainer()` Access to the surrounding container object.
    `net.sf.saxon.s9api.XdmNode` | `getDocument()` Access to the surrounding XdmDocument from the XMLFragment.
    `XBRLInstance` | `getInstance()` Access to the instance document on the top of this facts container hierarchy.
    `java.util.Iterator<java.util.Vector<XBRLFactItem>>` | `getItems()` Iterator over the items on this facts container.
    `java.util.Iterator<XBRLFactItem>` | `getItems(XBRLItem itemFrom)` Iterator over fact items that are instances of the XBRLItem received as a parameter.
    `java.util.Iterator<XBRLFactItem>` | `getItemsSg(XBRLItem itemFrom)` Iterator over fact items that are instances of the XBRLItem received as a parameter of in the substitution group of that item.
    `int` | `getNumberOfTuples()` Calculates and returns the number of tuples children of this facts container .
    `XBRLFactsList` | `getParent()` Access to the parent document, Instance or tuple.
    `java.util.Iterator<java.util.Vector<XBRLFactTuple>>` | `getTuples()` Iterator over the tuples on this facts container.
    `java.util.Iterator<XBRLFactTuple>` | `getTuples(XBRLTuple tupleFrom)` Iterator over fact tuples that are instances of the XBRLTuple received as a parameter.
    `java.util.Iterator<XBRLFactTuple>` | `getTuplesSg(XBRLTuple tupleFrom)` Iterator over fact tuples that are instances of the XBRLTuple received as a parameter of in the substitution group of that tuple.
    `java.lang.String` | `getXPathToRoot()` Access to the surrounding method from the XMLFragment.
    `int` | `hashCode()` This is from the Object interface and must be implemented by sub classes in order to be able to provide hashCodes.
    `int` | `indexOf(XBRLFact fact)` Returns the index position of a fact within this list.
    `int` | `indexOf(XBRLFact fact, int index)` Returns the index position of a fact within this list starting at the position indicated by the index parameter.
    `boolean` | `isXdmDocumentAttached()` Checks if is xdm document attached.
    `java.util.Iterator<XBRLFact>` | `iterator()` Iterator.
    `boolean` | `remove(XBRLFact fact)` Removes a fact from the facts container.
    `void` | `setParent(XBRLFactsList parent)` Sets the parent of this facts container to a new parent.
    `int` | `size()` Access to the number of elements in the XBRLFactList.

    - ### Methods inherited from interface com.ihr.xbrl.om.XMLHasParent

      `addXMLChild, getBase, removeXMLChild, setParent`

- - ### Method Detail

    - #### getParent

          XBRLFactsList getParent()

      Access to the parent document, Instance or tuple.
      Specified by:
        `getParent` in interface `XMLHasParent`
      Returns:
        XMLFragment that is a XBRLInstance or XBRLFactTuple

    - #### setParent

          void setParent(XBRLFactsList parent)

      Sets the parent of this facts container to a new parent.
      Parameters:
        `parent` - the new parent

    - #### add

          boolean add(XBRLFact fact)

      Adds a new fact to the end of this list of facts.
      Parameters:
        `fact` - the fact
      Returns:
        true, if successful

    - #### add

          void add(int index,
                 XBRLFact fact)

      Adds the.
      Parameters:
        `index` - the index
        `fact` - the fact

    - #### get

          XBRLFact get(int index)

      Returns the element at the selected index position. The first element is at position 0
      Parameters:
        `index` - integer
      Returns:
        XBRLFact at position indicated by index parameter

    - #### remove

          boolean remove(XBRLFact fact)

      Removes a fact from the facts container.
      Parameters:
        `fact` - the fact
      Returns:
        boolean

    - #### getInstance

          XBRLInstance getInstance()

      Access to the instance document on the top of this facts container hierarchy.
      Returns:
        XBRLInstance

    - #### iterator

          java.util.Iterator<XBRLFact> iterator()

      Iterator.
      Returns:
        the iterator

    - #### size

          int size()

      Access to the number of elements in the XBRLFactList.
      Returns:
        integer

    - #### getItems

          java.util.Iterator<java.util.Vector<XBRLFactItem>> getItems()

      Iterator over the items on this facts container.
      Returns:
        Iterator<Vector<XBRLFactItem>>

    - #### getItems

          java.util.Iterator<XBRLFactItem> getItems(XBRLItem itemFrom)

      Iterator over fact items that are instances of the XBRLItem received as a parameter.
      Parameters:
        `itemFrom` - XBRLItem
      Returns:
        Iterator<XBRLFactItem>

    - #### getItemsSg

          java.util.Iterator<XBRLFactItem> getItemsSg(XBRLItem itemFrom)

      Iterator over fact items that are instances of the XBRLItem received as a parameter of in the substitution group of that item.
      Parameters:
        `itemFrom` - XBRLItem
      Returns:
        Iterator<XBRLFactItem>

    - #### getTuples

          java.util.Iterator<java.util.Vector<XBRLFactTuple>> getTuples()

      Iterator over the tuples on this facts container.
      Returns:
        Iterator<Vector<XBRLFactTuple>>

    - #### getTuples

          java.util.Iterator<XBRLFactTuple> getTuples(XBRLTuple tupleFrom)

      Iterator over fact tuples that are instances of the XBRLTuple received as a parameter.
      Parameters:
        `tupleFrom` - XBRLTuple
      Returns:
        Iterator<XBRLFactTuple>

    - #### getTuplesSg

          java.util.Iterator<XBRLFactTuple> getTuplesSg(XBRLTuple tupleFrom)

      Iterator over fact tuples that are instances of the XBRLTuple received as a parameter of in the substitution group of that tuple.
      Parameters:
        `tupleFrom` - the tuple from
      Returns:
        Iterator<XBRLFactTuple>

    - #### getNumberOfTuples

          int getNumberOfTuples()

      Calculates and returns the number of tuples children of this facts container .
      Returns:
        integer value

    - #### getContainer

          DTSContainer getContainer()

      Access to the surrounding container object.
      Returns:
        DTSContainer

    - #### addOrForwardItem

          void addOrForwardItem(XBRLFactItem item)

      Called internally to register new facts in the instance document.
      Parameters:
        `item` - the item

    - #### getDocument

          net.sf.saxon.s9api.XdmNode getDocument()

      Access to the surrounding XdmDocument from the XMLFragment.
      Returns:
        XdmNode according to saxon s9api

    - #### getXPathToRoot

          java.lang.String getXPathToRoot()

      Access to the surrounding method from the XMLFragment.
      Returns:
        String

    - #### evaluateList

          net.sf.saxon.s9api.XdmValue evaluateList(java.lang.String string)

      Access to the surrounding method in the XMLFragment.
      Parameters:
        `string` - the string
      Returns:
        an XdmValue from the saxonica s9api

    - #### indexOf

          int indexOf(XBRLFact fact)

      Returns the index position of a fact within this list.
      Parameters:
        `fact` - XBRLFact
      Returns:
        integer

    - #### indexOf

          int indexOf(XBRLFact fact,
                    int index)

      Returns the index position of a fact within this list starting at the position indicated by the index parameter.
      Parameters:
        `fact` - XBRLFact
        `index` - integer
      Returns:
        integer

    - #### clear

          void clear()
                     throws java.lang.Throwable

      Removes all children elements in this XBRLFactList.
      Throws:
        `java.lang.Throwable` - the throwable

    - #### hashCode

          int hashCode()

      This is from the Object interface and must be implemented by sub classes in order to be able to provide hashCodes.
      Overrides:
        `hashCode` in class `java.lang.Object`
      Returns:
        integer

    - #### equals

          boolean equals(java.lang.Object obj)

      This function should be implemented by sub classes in order to properly implement.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `obj` - Object to compare to
      Returns:
        boolean value

    - #### isXdmDocumentAttached

          boolean isXdmDocumentAttached()

      Checks if is xdm document attached.
      Returns:
        true, if is xdm document attached